/**
 * Objeto que controla dados do usuário
 * @type {Object}
 */
var user = {

  /**
   * Útil para verificar se já foi feito cadastro ou login
   * @return {Boolean}
   */
  has: function() {
    debug.msg("Checking if has some user in");
    if (localStorage.user == undefined)
      return false;
    else
      return true;
  },

  /**
   * @param {object} - Dados do usuário
   */
  setInfo: function(data) {
    localStorage.userInfo = JSON.stringify(data);
  },

  /**
   * @return {string} - Id do usuário criptografado
   */
  getInfo: function() {
    if (localStorage.userInfo)
      return JSON.parse(localStorage.userInfo);
    else return false;
  },

  /**
   * Verifica se existe alguma informação do usuário nula.
   * @return {integer}
   */
  hasInfo: function() {
    var has = 0
    $.each(user.getInfo(), function(e, value) {
      if (!value)
        has += 1;
    });
    return has;
  },

  /**
   * Solicita os dados do usuário
   */
  postInfo: function() {
    $.post("get-profile", {},
      function(data) {
        //      console.log(data);
        user.setInfo(data);
        if (user.hasInfo() > 0) {
          $.dialog.confirm("", "Seus dados estão incompletos. Deseja atualizar agora?", function() {
            location.hash = "#view-profile";
            $.dialog.close();
          });
        }
      },
      function() {
        console.log("erro");
        return false;
      }
    );
  },

  /**
   * @return {string} - Id do usuário criptografado
   */
  getId: function() {
    return localStorage.user;
  },

  /**
   * @param {string} - Id do usuário criptografado
   */
  setId: function(id) {
    localStorage.user = id;
  },

  /**
   * @return {string} - gcmid
   */
  getGcm: function() {
    return localStorage.gcmid;
  },

  /**
   * @param {string} - gcmid
   */
  setGcm: function(gcm) {
    localStorage.gcmid = gcm;
  },

  getStatus: function() {
    return localStorage.status;
  },

  setStatus: function(status) {
    localStorage.status = status;
  },

  /**
   * @return {null}
   */
  ping: function() {
    var data = {
      id: this.getId(),
      latitude: aLatitude,
      longitude: aLongitude,
      model: device.model,
      version_so: device.version,
      uuid: device.uuid,
      gcm: this.getGcm(),
      version_app: versionApp
    };
    // alert(JSON.stringify(data));
    $.post("ping-status", data, function(data) {
      user.setStatus(data.status);
      if (user.getStatus() == "D") {
        $.dialog.info("Bloqueado", "Sua conta foi bloqueada. Entre em contato com suporte@taximoto.com.");
      } else if (user.getStatus() == "E" || user.getStatus() == "C" || user.getStatus() == "R") {
        $("#button-status").prop('checked', true).change();
      }
      return true;
    }, function() {
      $.alert("Erro ao conectar com o servidor.");
      return false;
    });
  },

  /**
   * [logout description]
   * @return {[type]} [description]
   */
  logout: function() {
    $.dialog.confirm("Logout", "Tem certeza que deseja fazer logout?", function() {
      $.post("logout", {}, function() {
          delete(localStorage.user);
          user.setStatus("B");
          $("#submenu").addClass("bg-offline");
          $("#submenu").removeClass("bg-online");
          $("#submenu").html("Fora de serviço");
          $("#button-status").prop('checked', false);
          gps.setWatchMotion(false);
          cordova.plugins.backgroundMode.disable();
          routes();
        },
        function() {
          $.alert("Não foi possível fazer o logout. Tente novamente mais tarde.");
        });
      $.dialog.close();
    });
  }
};
